Index: trunk/src/world_entities/weather_effects/rain_effect.h
===================================================================
--- trunk/src/world_entities/weather_effects/rain_effect.h	(revision 9869)
+++ trunk/src/world_entities/weather_effects/rain_effect.h	(revision 9869)
@@ -0,0 +1,144 @@
+/**
+ * @file rain_effect.h
+ * Generates rain using the particle engine
+*/
+
+#ifndef _RAIN_EFFECT
+#define _RAIN_EFFECT
+
+#include "weather_effect.h"
+
+#include "vector.h"
+#include "vector2D.h"
+#include <string>
+
+#include "particles/particle_system.h"
+
+class SparkParticles;
+class PlainEmitter;
+class LightManager;
+class CloudEffect;
+
+#include "sound_buffer.h"
+#include "sound_source.h"
+
+class RainEffect : public WeatherEffect
+{
+  ObjectListDeclaration(RainEffect);
+public:
+  RainEffect(const TiXmlElement* root = NULL);
+  virtual ~RainEffect();
+
+  virtual void loadParams(const TiXmlElement* root);
+
+  virtual void init();
+
+  virtual void activate();
+  virtual void deactivate();
+
+  inline void activateRain()
+  {
+    this->activate();
+  }
+
+  inline void deactivateRain()
+  {
+    this->deactivate();
+  }
+
+  virtual void tick(float dt);
+
+  void startRaining();
+  void stopRaining();
+
+  void hideRain();
+
+  inline void setRainCoord(float x, float y, float z)
+  {
+    this->rainCoord = Vector(x, y, z);
+  }
+  inline void setRainSize(float x, float y)
+  {
+    this->rainSize = Vector2D(x, y);
+  }
+  inline void setRainRate(float rate)
+  {
+    this->rainRate = rate;
+  }
+  inline void setRainVelocity(float velocity)
+  {
+    this->rainVelocity = -velocity;
+  }
+  inline void setRainLife(float life)
+  {
+    this->rainLife = life;
+  }
+  inline void setRainWind(int force)
+  {
+    this->rainWindForce = force;
+  }
+
+  inline void setRainFadeIn(float fadein)
+  {
+    this->rainFadeInDuration = fadein;
+  }
+  inline void setRainFadeOut(float fadeout)
+  {
+    this->rainFadeOutDuration = fadeout;
+  }
+
+  inline void setCloudColor(float colorX, float colorY, float colorZ)
+  {
+    this->cloudColor = Vector(colorX, colorY, colorZ);
+  }
+  inline void setSkyColor(float colorX, float colorY, float colorZ)
+  {
+    this->skyColor = Vector(colorX, colorY, colorZ);
+  }
+
+  inline void setRainOption(const std::string& option)
+  {
+    if (option == "moverain")
+      this->rainMove = true;
+    if (option == "activate")
+      this->rainActivate = true;
+  }
+
+
+private:
+  static SparkParticles*      rainParticles;
+  ParticleEmitter*            emitter;
+
+  float                       localTimer;
+
+  GLfloat                     rainFadeInDuration;
+  GLfloat                     rainFadeOutDuration;
+  bool                        rainFadeInActivate;
+  bool                        rainFadeOutActivate;
+
+  Vector                      rainCoord;
+  Vector2D                    rainSize;
+  GLfloat                     rainRate;
+  GLfloat                     rainVelocity;
+  GLfloat                     rainLife;
+  GLfloat                     rainMaxParticles;
+  int                         rainWindForce;
+  bool                        rainMove;
+  bool                        rainActivate;
+
+  OrxSound::SoundSource       soundSource;
+  OrxSound::SoundBuffer       rainBuffer;
+  OrxSound::SoundBuffer       windBuffer;
+
+  float                       soundRainVolume;
+
+  Vector                      oldSkyColor;
+  Vector                      oldCloudColor;
+  Vector                      skyColor;
+  Vector                      cloudColor;
+
+  LightManager*               lightMan;
+
+};
+
+#endif  /* _RAIN_EFFECT */
Index: trunk/src/world_entities/weather_effects/snow_effect.cc
===================================================================
--- trunk/src/world_entities/weather_effects/snow_effect.cc	(revision 9869)
+++ trunk/src/world_entities/weather_effects/snow_effect.cc	(revision 9869)
@@ -0,0 +1,233 @@
+/*
+        orxonox - the future of 3D-vertical-scrollers
+
+        Copyright (C) 2004 orx
+
+        This program is free software; you can redistribute it and/or modify
+        it under the terms of the GNU General Public License as published by
+        the Free Software Foundation; either version 2, or (at your option)
+        any later version.
+
+### File Specific:
+        main-programmer: hdavid, amaechler
+*/
+
+#include "snow_effect.h"
+
+#include "util/loading/load_param.h"
+#include "util/loading/factory.h"
+#include "sound/resource_sound_buffer.h"
+
+#include "glincl.h"
+#include "debug.h"
+
+#include "p_node.h"
+#include "state.h"
+#include "particles/sprite_particles.h"
+#include "particles/plane_emitter.h"
+#include "shell_command.h"
+#include "script_class.h"
+#include "cloud_effect.h"
+
+#include "class_id_DEPRECATED.h"
+
+ObjectListDefinitionID(SnowEffect, CL_SNOW_EFFECT);
+SHELL_COMMAND(activate, SnowEffect, activateSnow);
+SHELL_COMMAND(deactivate, SnowEffect, deactivateSnow);
+
+
+CREATE_SCRIPTABLE_CLASS(SnowEffect,
+                        addMethod("activate", Executor0<SnowEffect, lua_State*>(&SnowEffect::activate))
+                        ->addMethod("deactivate", Executor0<SnowEffect, lua_State*>(&SnowEffect::deactivate))
+                       );
+
+CREATE_FACTORY(SnowEffect);
+
+SnowEffect::SnowEffect(const TiXmlElement* root)
+{
+  this->registerObject(this, SnowEffect::_objectList);
+
+  this->init();
+
+  if (root != NULL)
+    this->loadParams(root);
+
+  //load wind sound
+  if (this->snowWindForce >= 1)
+  {
+    this->windBuffer = OrxSound::ResourceSoundBuffer("sound/atmosphere/wind.wav");
+  }
+
+  if(snowActivate)
+  {
+    this->activate();
+    SnowEffect::snowParticles->precache((int) this->snowLife);
+  }
+}
+
+
+SnowEffect::~SnowEffect()
+{
+  this->deactivate();
+}
+
+SpriteParticles* SnowEffect::snowParticles = NULL;
+
+void SnowEffect::loadParams(const TiXmlElement* root)
+{
+  WeatherEffect::loadParams(root);
+
+  LoadParam(root, "numParticles", this, SnowEffect, numParticles);
+  LoadParam(root, "materialTexture", this, SnowEffect, materialTexture);
+  LoadParam(root, "lifeSpans", this, SnowEffect, lifeSpan);
+  LoadParam(root, "radius", this, SnowEffect, radius);
+  LoadParam(root, "mass", this, SnowEffect, mass);
+  LoadParam(root, "emissionRate", this, SnowEffect, emissionRate);
+  LoadParam(root, "emissionVelocity", this, SnowEffect, emissionVelocity);
+  LoadParam(root, "wind", this, SnowEffect, wind);
+  LoadParam(root, "size", this, SnowEffect, size);
+  LoadParam(root, "coord", this, SnowEffect, coord);
+  LoadParam(root, "cloudcolor", this, SnowEffect, setCloudColor);
+  LoadParam(root, "skycolor", this, SnowEffect, setSkyColor);
+  LoadParam(root, "fadetime", this, SnowEffect, setFadeTime);
+
+  LOAD_PARAM_START_CYCLE(root, element);
+  {
+    LoadParam_CYCLE(element, "option", this, SnowEffect, setSnowOption);
+  }
+  LOAD_PARAM_END_CYCLE(element);
+}
+
+void SnowEffect::init()
+{
+  this->emitter = new PlaneEmitter();
+
+  // Default values
+  this->snowActivate = false;
+  this->snowMove = false;
+  this->particles = 12000;
+  this->texture = "maps/snow_flake_01_32x32.png";
+  this->snowLife = 8;
+  this->randomLife = 2;
+  this->snowRadius = 3.5;
+  this->randomRadius = 1;
+  this->snowMass = 1.0;
+  this->randomMass = 0.3;
+  this->rate = 900;
+  this->velocity = -100;
+  this->randomVelocity = 5;
+  this->angle = 0.5;
+  this->randomAngle = 0.2;
+  this->alpha = 0.5;
+  this->snowSize = Vector2D(2500, 2500);
+  this->snowCoord = Vector(100,450,400);
+  this->snowWindForce = 1;
+
+  this->fadeTime = 10;
+  this->cloudColor = Vector(0.2f, 0.2f, 0.2f);
+  this->skyColor = Vector(0.0f, 0.0f, 0.0f);
+}
+
+void SnowEffect::activate()
+{
+  PRINTF(3)("Activating SnowEffect\n");
+
+  this->snowActivate = true;
+
+  SnowEffect::snowParticles = new SpriteParticles(particles);
+  SnowEffect::snowParticles->setName("SnowEffectTrailParticles");
+  SnowEffect::snowParticles->setMaterialTexture(texture);
+  SnowEffect::snowParticles->setLifeSpan(snowLife, randomLife);
+  SnowEffect::snowParticles->setRadius(0.0, snowRadius, randomRadius);
+  SnowEffect::snowParticles->setRadius(0.2, snowRadius, randomRadius*0.8);
+  SnowEffect::snowParticles->setRadius(1.0, snowRadius, randomRadius*0.5);
+  SnowEffect::snowParticles->setMass(0, snowMass, randomMass);
+  SnowEffect::snowParticles->setColor(0,1, 1, 1, alpha);
+  SnowEffect::snowParticles->setColor(.5, .6, .6, .6, alpha/2);
+  SnowEffect::snowParticles->setColor(1, .0, .0, .0, .0);
+
+  this->emitter->setSystem(SnowEffect::snowParticles);
+
+  this->emitter->setRelCoor(snowCoord);
+  this->emitter->setEmissionRate(rate);
+  this->emitter->setEmissionVelocity(velocity, randomVelocity);
+  this->emitter->setSpread(angle * this->snowWindForce , randomAngle * this->snowWindForce);
+  this->emitter->setSize(snowSize);
+
+  if (this->snowWindForce != 0)
+    this->soundSource.play(this->windBuffer, 0.1f * this->snowWindForce, true);
+
+  // Store cloud- and sky color before the snow
+  this->oldCloudColor = CloudEffect::cloudColor;
+  this->oldSkyColor   = CloudEffect::skyColor;
+
+  // Change the colors
+  CloudEffect::changeCloudColor(this->cloudColor, this->fadeTime);
+  CloudEffect::changeSkyColor(this->skyColor, this->fadeTime);
+
+}
+
+
+void SnowEffect::deactivate()
+{
+  PRINTF(3)("Deactivating SnowEffect\n");
+
+  this->snowActivate = false;
+  this->emitter->setSystem(NULL);
+
+  // Restore the old cloud- and sky color
+  CloudEffect::changeCloudColor(this->oldCloudColor, this->fadeTime);
+  CloudEffect::changeSkyColor(this->oldSkyColor, this->fadeTime);
+}
+
+void SnowEffect::draw() const
+{
+  if (!this->snowActivate)
+    return;
+}
+
+void SnowEffect::tick(float dt)
+{
+  if (!this->snowActivate)
+    return;
+
+  /*
+  float distance = (State::getCameraNode()->getAbsCoor() - Vector(snowCoord.x, State::getCameraNode()->getAbsCoor().y, snowCoord.z)).len();
+
+  if(activated)
+  {
+  if(distance > 0.3*snowSize.x || distance > 0.3*snowSize.y)
+                  this->deactivate();
+  else if(distance > 0.25*snowSize.x || distance > 0.25*snowSize.y)
+  this->alpha = 0.15;
+  else if(distance > 0.2*snowSize.x || distance > 0.2*snowSize.y)
+  this->alpha = 0.25;
+  else if(distance > 0.1*snowSize.x || distance > 0.1*snowSize.y)
+  this->alpha = 0.4;
+
+  SnowEffect::snowParticles->setColor(0,1, 1, 1, alpha);
+  SnowEffect::snowParticles->setColor(.5, .6, .6, .6, alpha/2);
+  SnowEffect::snowParticles->setColor(1, .0, .0, .0, .0);
+  }
+  else
+  {
+  if(distance < 0.3*snowSize.x || distance < 0.3*snowSize.y )
+  this->activate();
+  if( distance < 0.25*snowSize.x || distance < 0.25*snowSize.y )
+  this->alpha = 0.25;
+  else if( distance < 0.2*snowSize.x || distance < 0.2*snowSize.y )
+  this->alpha = 0.4;
+  else if( distance < 0.1*snowSize.x || distance < 0.1*snowSize.y )
+  this->alpha = 0.5;
+
+  SnowEffect::snowParticles->setColor(0,1, 1, 1, alpha);
+  SnowEffect::snowParticles->setColor(.5, .6, .6, .6, alpha/2);
+  SnowEffect::snowParticles->setColor(1, .0, .0, .0, .0);
+  }*/
+
+  if (this->snowMove)
+  {
+    this->snowCoord = State::getCameraNode()->getAbsCoor();
+    this->emitter->setRelCoor(this->snowCoord.x , this->snowCoord.y+300, this->snowCoord.z);
+  }
+}
Index: trunk/src/world_entities/weather_effects/snow_effect.h
===================================================================
--- trunk/src/world_entities/weather_effects/snow_effect.h	(revision 9869)
+++ trunk/src/world_entities/weather_effects/snow_effect.h	(revision 9869)
@@ -0,0 +1,148 @@
+/**
+* @file snow_effect.h
+*/
+
+#ifndef _SNOW_EFFECT
+#define _SNOW_EFFECT
+
+#include "vector.h"
+#include "particles/particle_system.h"
+#include "material.h"
+#include "vector2D.h"
+
+#include "weather_effect.h"
+
+class SpriteParticles;
+class PlaneEmitter;
+class PNode;
+class CloudEffect;
+
+#include "sound_source.h"
+#include "sound_buffer.h"
+
+class SnowEffect : public WeatherEffect
+{
+  ObjectListDeclaration(SnowEffect);
+public:
+  SnowEffect(const TiXmlElement* root = NULL);
+  virtual ~SnowEffect();
+
+  virtual void loadParams(const TiXmlElement* root);
+
+  virtual void init();
+
+  virtual void activate();
+  virtual void deactivate();
+
+  inline void activateSnow()
+  {
+    this->activate();
+  }
+  inline void deactivateSnow()
+  {
+    this->deactivate();
+  }
+
+  virtual void draw() const;
+  virtual void tick(float dt);
+
+
+  inline void numParticles(int n)
+  {
+    this->particles = n;
+  }
+  inline void materialTexture(const std::string& texture)
+  {
+    this->texture = texture;
+  }
+  inline void lifeSpan(float lifeSpan, float randomLifeSpan)
+  {
+    this->snowLife = lifeSpan;
+    this->randomLife = randomLifeSpan;
+  }
+  inline void radius(float radius, float randomRadius)
+  {
+    this->snowRadius = radius;
+    this->randomRadius = randomRadius;
+  }
+  inline void mass(float mass, float randomMass)
+  {
+    this->snowMass = mass;
+    this->randomMass = randomMass;
+  }
+  inline void emissionRate(float emissionRate)
+  {
+    this->rate = emissionRate;
+  }
+  inline void emissionVelocity(float velocity, float randomVelocity)
+  {
+    this->velocity = velocity;
+    this->randomVelocity = randomVelocity;
+  }
+  inline void size(float sizeX, float sizeY)
+  {
+    this->snowSize = Vector2D(sizeX, sizeY);
+  }
+  inline void coord(float x, float y, float z)
+  {
+    this->snowCoord = Vector(x, y, z);
+  }
+  inline void wind(int force)
+  {
+    this->snowWindForce = force;
+  }
+  inline void setCloudColor(float colorX, float colorY, float colorZ)
+  {
+    this->cloudColor = Vector(colorX, colorY, colorZ);
+  }
+  inline void setSkyColor(float colorX, float colorY, float colorZ)
+  {
+    this->skyColor = Vector(colorX, colorY, colorZ);
+  }
+  inline void setFadeTime(float time)
+  {
+    this->fadeTime = time;
+  }
+
+  inline void setSnowOption(const std::string& option)
+  {
+    /*if (option == "fade") this->snowFade = true;*/
+    if (option == "movesnow")
+      this->snowMove = true;
+    if (option == "activate")
+      this->snowActivate = true;
+  }
+
+
+private:
+  int               particles;
+  std::string       texture;
+  float             snowLife, randomLife;
+  float             snowRadius, randomRadius;
+  float             snowMass, randomMass;
+  float             rate;
+  float             velocity, randomVelocity;
+  float             angle, randomAngle;
+  float             alpha;
+  float             fadeTime;
+  Vector            snowCoord;
+  Vector2D          snowSize;
+  int               snowWindForce;
+
+  bool              snowMove;
+  bool              snowActivate;
+
+  PlaneEmitter*     emitter;
+
+  static SpriteParticles*   snowParticles;
+  OrxSound::SoundSource     soundSource;
+  OrxSound::SoundBuffer     windBuffer;
+
+  Vector            oldSkyColor;
+  Vector            oldCloudColor;
+  Vector            skyColor;
+  Vector            cloudColor;
+};
+
+
+#endif  /* _SNOW_EFFECT */
Index: trunk/src/world_entities/weather_effects/sun_effect.cc
===================================================================
--- trunk/src/world_entities/weather_effects/sun_effect.cc	(revision 9869)
+++ trunk/src/world_entities/weather_effects/sun_effect.cc	(revision 9869)
@@ -0,0 +1,76 @@
+
+
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+### File Specific:
+   main-programmer: hdavid, amaechler
+*/
+
+
+#include "sun_effect.h"
+
+#include "util/loading/load_param.h"
+
+
+
+
+
+
+/**
+ * @param root The XML-element to load the SunEffect from
+ */
+SunEffect::SunEffect(const TiXmlElement* root)
+{
+//  this->setClassID(CL_SUN_EFFECT, "SunEffect");
+  this->bActivated = false;
+}
+
+
+/**
+ *  destroys a SunEffect
+ */
+SunEffect::~SunEffect()
+{
+
+}
+
+
+/**
+ * @param root The XML-element to load the SunEffect from
+ */
+void SunEffect::loadParams(const TiXmlElement* root)
+{
+  BaseObject::loadParams(root);
+}
+
+
+/**
+ *  initializes the graphics effect
+ */
+void SunEffect::init()
+{}
+
+
+
+/**
+ * draws the effect, if needed
+ */
+void SunEffect::draw() const
+{}
+
+
+
+/**
+ * ticks the effect if there is any time dependancy
+ */
+void SunEffect::tick(float dt)
+{}
+
Index: trunk/src/world_entities/weather_effects/sun_effect.h
===================================================================
--- trunk/src/world_entities/weather_effects/sun_effect.h	(revision 9869)
+++ trunk/src/world_entities/weather_effects/sun_effect.h	(revision 9869)
@@ -0,0 +1,37 @@
+/*!
+ * @file sun_effect.h
+ *
+ */
+
+#ifndef _SUN_EFFECT_H
+#define _SUN_EFFECT_H
+
+#include "base_object.h"
+
+
+class TiXmlElement;
+
+class SunEffect : public BaseObject
+{
+  public:
+    SunEffect(const TiXmlElement* root = NULL);
+    virtual ~SunEffect();
+
+    virtual void loadParams(const TiXmlElement* root);
+
+    virtual void init();
+
+    virtual void activate() = 0;
+    virtual void deactivate() = 0;
+
+    virtual void draw() const;
+    virtual void tick(float dt);
+
+    inline bool isActivated() const { return this->bActivated; }
+
+  protected:
+    bool              bActivated;
+};
+
+
+#endif /* _SUN_EFFECT */
Index: trunk/src/world_entities/weather_effects/volfog_effect.cc
===================================================================
--- trunk/src/world_entities/weather_effects/volfog_effect.cc	(revision 9869)
+++ trunk/src/world_entities/weather_effects/volfog_effect.cc	(revision 9869)
@@ -0,0 +1,198 @@
+/*
+  orxonox - the future of 3D-vertical-scrollers
+
+  Copyright (C) 2004 orx
+
+  This program is free software; you can redistribute it and/or modify
+  it under the terms of the GNU General Public License as published by
+  the Free Software Foundation; either version 2, or (at your option)
+  any later version.
+
+### File Specific:
+  main-programmer: hdavid, amaechler
+*/
+
+#include "volfog_effect.h"
+
+#include "util/loading/load_param.h"
+#include "util/loading/factory.h"
+
+#include "p_node.h"
+#include "state.h"
+
+#include "glincl.h"
+//#include "shell_command.h"
+#include "debug.h"
+
+
+#define GLX_GLXEXT_PROTOTYPES
+//#include <GL/glx.h>
+// #include <GL/glut.h>
+
+//#include <GL/glext.h> //OpenGL Extensions
+//#include <GL/glxext.h> // GLX Extensions
+
+#ifndef GL_EXT_fog_coord
+#define GL_EXT_fog_coord 1
+typedef void (APIENTRY * PFNGLFOGCOORDFEXTPROC) (GLfloat coord);
+typedef void (APIENTRY * PFNGLFOGCOORDFVEXTPROC) (const GLfloat *coord);
+typedef void (APIENTRY * PFNGLFOGCOORDDEXTPROC) (GLdouble coord);
+typedef void (APIENTRY * PFNGLFOGCOORDDVEXTPROC) (const GLdouble *coord);
+typedef void (APIENTRY * PFNGLFOGCOORDPOINTEREXTPROC) (GLenum type, GLsizei stride, const GLvoid *pointer);
+#endif
+
+PFNGLFOGCOORDFEXTPROC glFogCoordfEXT = 0;
+PFNGLFOGCOORDFVEXTPROC glFogCoordfvEXT = 0;
+PFNGLFOGCOORDDEXTPROC glFogCoorddEXT = 0;
+PFNGLFOGCOORDDVEXTPROC glFogCoorddvEXT = 0;
+PFNGLFOGCOORDPOINTEREXTPROC glFogCoordPointerEXT = 0;
+
+
+#include "class_id_DEPRECATED.h"
+ObjectListDefinitionID(VolFogEffect, CL_VOLFOG_EFFECT);
+CREATE_FACTORY(VolFogEffect);
+
+VolFogEffect::VolFogEffect(const TiXmlElement* root) {
+  this->registerObject(this, VolFogEffect::_objectList);
+
+    if (root != NULL)
+        this->loadParams(root);
+
+    // Initialize Effect
+    this->init();
+
+    // Activate Effect
+    this->activate();
+}
+
+
+VolFogEffect::~VolFogEffect() {
+    this->deactivate();
+}
+
+void VolFogEffect::loadParams(const TiXmlElement* root) {
+    WeatherEffect::loadParams(root);
+}
+
+void VolFogEffect::init() {
+    PRINTF(3)("Initalize VolFogEffect\n");
+
+    // set fog mode
+    GLenum fogMode  = GL_EXP;
+
+    // set fog density
+    float  fogDensity  = 0.001f;
+
+    // set fog near & far distance
+    float fogStart = 0.0f;
+    float fogEnd   = 1000.0f;
+
+    // Set fog color
+    float fogColor[4] = {0.6f,0.58f,0.79f,0.0f};
+
+
+    /*    glFogCoordfEXT       = (PFNGLFOGCOORDFEXTPROC)glXGetProcAddressARB((const GLubyte*)"glFogCoordfEXT");
+    glFogCoordfvEXT      = (PFNGLFOGCOORDFVEXTPROC)glXGetProcAddressARB((const GLubyte*)"glFogCoordfvEXT");
+    glFogCoorddEXT       = (PFNGLFOGCOORDDEXTPROC)glXGetProcAddressARB((const GLubyte*)"glFogCoorddEXT");
+    glFogCoorddvEXT      = (PFNGLFOGCOORDDVEXTPROC)glXGetProcAddressARB((const GLubyte*)"glFogCoorddvEXT");
+    glFogCoordPointerEXT = (PFNGLFOGCOORDPOINTEREXTPROC)glXGetProcAddressARB((const GLubyte*)"glFogCoordPointerEXT");
+    */
+    // set the fog attributes
+    glFogf (GL_FOG_START,  fogStart);
+    glFogf (GL_FOG_END,    fogEnd);
+    glFogfv(GL_FOG_COLOR,  fogColor);
+    glFogi (GL_FOG_MODE,   fogMode);
+    glFogf (GL_FOG_DENSITY,fogDensity);
+    glFogi (GL_FOG_COORDINATE_SOURCE_EXT,GL_FOG_COORDINATE_EXT);
+
+    // enable the fog
+    glEnable(GL_FOG);
+
+    if (glewInit() == GLEW_OK)
+        PRINTF(4)("glewInit OK\n");
+    else
+        PRINTF(4)("glewInit failed\n");
+
+    if (glewGetExtension("GL_EXT_fog_coord"))
+        PRINTF(4)("GL_EXT_fog_coord extension found\n");
+}
+
+
+void VolFogEffect::activate() {
+    PRINTF(3)("Activating VolFogEffect\n");
+}
+
+void VolFogEffect::deactivate() {
+    PRINTF(3)("Deactivating VolFogEffect\n");
+
+    glDisable(GL_FOG);
+}
+
+
+/**
+* draws the effect, if needed
+*/
+void VolFogEffect::draw() const {
+    glPushAttrib(GL_ENABLE_BIT);
+    glClearColor(fogColor[0],fogColor[1],fogColor[2],0.0f);
+    glShadeModel(GL_SMOOTH);
+    glEnable(GL_DEPTH_TEST);
+    glEnable(GL_CULL_FACE);
+    glCullFace(GL_BACK);
+
+    /* clear all pixels in colour buffer */
+    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
+
+    /* Enable blending */
+    //glEnable(GL_BLEND);
+    //glBlendFunc(GL_SRC_ALPHA, GL_DST_ALPHA);
+
+    int i;
+    glLoadIdentity();
+
+
+    glBegin( GL_LINES );
+    glNormal3f(0,1,0);
+    for(i=-20;i<=20;i+=2) {
+        float fog_c;
+        float diff[3];
+
+        diff[0] = State::getCameraNode()->getAbsCoor().x - i;
+        diff[2] = State::getCameraNode()->getAbsCoor().z + 20;
+        diff[1] = State::getCameraNode()->getAbsCoor().y;
+        fog_c = 1.3f*sqrt(diff[0]*diff[0]+diff[1]*diff[1]+diff[2]*diff[2]);
+        glFogCoordfEXT(fog_c*2);
+        glVertex3f(i,0,-20);
+
+        diff[0] = State::getCameraNode()->getAbsCoor().x - i;
+        diff[2] = State::getCameraNode()->getAbsCoor().z + 20;
+        diff[1] = State::getCameraNode()->getAbsCoor().y;
+        fog_c = 1.3f*sqrt(diff[0]*diff[0]+diff[1]*diff[1]+diff[2]*diff[2]);
+        glFogCoordfEXT(fog_c*2);
+        glVertex3f(i,0,20);
+
+        diff[0] = State::getCameraNode()->getAbsCoor().x - i;
+        diff[2] = State::getCameraNode()->getAbsCoor().z + 20;
+        diff[1] = State::getCameraNode()->getAbsCoor().y;
+        fog_c = 1.3f*sqrt(diff[0]*diff[0]+diff[1]*diff[1]+diff[2]*diff[2]);
+        glFogCoordfEXT(fog_c*2);
+        glVertex3f(-20,0,i);
+
+        diff[0] = State::getCameraNode()->getAbsCoor().x - i;
+        diff[2] = State::getCameraNode()->getAbsCoor().z + 20;
+        diff[1] = State::getCameraNode()->getAbsCoor().y;
+        fog_c = 1.3f*sqrt(diff[0]*diff[0]+diff[1]*diff[1]+diff[2]*diff[2]);
+        glFogCoordfEXT(fog_c*2);
+        glVertex3f(20,0,i);
+    }
+    glEnd();
+
+    glPopAttrib();
+
+}
+
+
+/**
+* ticks the effect if there is any time dependancy
+*/
+void VolFogEffect::tick(float dt) {}
Index: trunk/src/world_entities/weather_effects/volfog_effect.h
===================================================================
--- trunk/src/world_entities/weather_effects/volfog_effect.h	(revision 9869)
+++ trunk/src/world_entities/weather_effects/volfog_effect.h	(revision 9869)
@@ -0,0 +1,35 @@
+/**
+* @file volfog_effect.h
+*/
+
+#ifndef _VOLFOG_EFFECT
+#define _VOLFOG_EFFECT
+
+#include "vector.h"
+
+#include "weather_effect.h"
+#include "glincl.h"
+
+class VolFogEffect : public WeatherEffect
+{
+  ObjectListDeclaration(VolFogEffect);
+public:
+  VolFogEffect(const TiXmlElement* root = NULL);
+  virtual ~VolFogEffect();
+
+  virtual void loadParams(const TiXmlElement* root);
+
+  virtual void init();
+
+  virtual void activate();
+  virtual void deactivate();
+
+  virtual void draw() const;
+  virtual void tick(float dt);
+
+private:
+  GLfloat fogColor[4];
+
+};
+
+#endif  /* _VOLFOG_EFFECT */
Index: trunk/src/world_entities/weather_effects/weather_effect.cc
===================================================================
--- trunk/src/world_entities/weather_effects/weather_effect.cc	(revision 9869)
+++ trunk/src/world_entities/weather_effects/weather_effect.cc	(revision 9869)
@@ -0,0 +1,74 @@
+
+
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+### File Specific:
+   main-programmer: hdavid, amaechler
+*/
+
+// TODO: descriptions to loadparams, movealong unified, start activation
+
+#include "weather_effect.h"
+#include "util/loading/load_param.h"
+
+ObjectListDefinition(WeatherEffect);
+
+/**
+ * @param root The XML-element to load the WeatherEffect from
+ */
+WeatherEffect::WeatherEffect(const TiXmlElement* root)
+{
+  this->registerObject(this, WeatherEffect::_objectList);
+  this->bActivated = false;
+}
+
+
+/**
+ *  destroys a WeatherEffects
+ */
+WeatherEffect::~WeatherEffect()
+{
+
+}
+
+
+/**
+ * @param root The XML-element to load the WeatherEffects from
+ */
+void WeatherEffect::loadParams(const TiXmlElement* root)
+{
+  BaseObject::loadParams(root);
+}
+
+
+/**
+ *  initializes the graphics effect
+ */
+void WeatherEffect::init()
+{
+}
+
+
+
+/**
+ * draws the effect, if needed
+ */
+void WeatherEffect::draw() const
+{}
+
+
+
+/**
+ * ticks the effect if there is any time dependancy
+ */
+void WeatherEffect::tick(float dt)
+{}
+
Index: trunk/src/world_entities/weather_effects/weather_effect.h
===================================================================
--- trunk/src/world_entities/weather_effects/weather_effect.h	(revision 9869)
+++ trunk/src/world_entities/weather_effects/weather_effect.h	(revision 9869)
@@ -0,0 +1,38 @@
+/*!
+ * @file weather_effect.h
+ *
+ */
+
+#ifndef _WEATHER_EFFECT_H
+#define _WEATHER_EFFECT_H
+
+#include "base_object.h"
+
+
+class WeatherEffect : public BaseObject
+{
+  ObjectListDeclaration(WeatherEffect);
+
+  public:
+    WeatherEffect(const TiXmlElement* root = NULL);
+    virtual ~WeatherEffect();
+
+    virtual void loadParams(const TiXmlElement* root);
+
+    virtual void init();
+
+    virtual void activate() = 0;
+    virtual void deactivate() = 0;
+
+    virtual void draw() const;
+    virtual void tick(float dt);
+
+    inline  bool isActivated() const { return this->bActivated; }
+
+
+  protected:
+    bool              bActivated;
+};
+
+
+#endif /* _WEATHER_EFFECT */
